---
title: "Introduction to rdb.report"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Introduction to rdb.report}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r}
#| label: setup
#| include: false

# attach pkgs
library(magrittr,
        include.only = c("%>%", "%<>%", "%T>%", "%!>%", "%$%"))
library(rlang,
        include.only = "%|%")

# set RNG seeds
set.seed(42L)
htmlwidgets::setWidgetIdSeed(seed = 42L)

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

# disable cache expiry
options(rdb.global_max_cache_age = Inf)

# set pkg metadata
pkg_metadata <- pal::desc_list()
```

# Organisation

This R package bundles together code and configuration to produce the yearly Referendum Database (RDB) report [*World of
Referendums*](https://report.rdb.vote/), including:

-   The Quarto project sources (under [`input/report/`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/)).
-   R code tailored to the RDB report (under the repository root), i.e. as the sources of the dedicated R package `rdb.report`.
-   Input files generated via functions from the `rdb.report` package like [`rdb.report::preassemble()`](https://rdb.report.rpkg.dev/reference/preassemble)
    (under [`input/generated/`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/generated/)).
-   The generated Quarto output (under [`output/report/`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/output/report/)), which is directly deployed
    from the [GitLab repository's `master` branch](https://gitlab.com/zdaarau/rpkgs/rdb.report/tree/master/output/report/) to
    [report.rdb.vote](https://report.rdb.vote/) via [Netlify](https://app.netlify.com/sites/report-rdb-vote/deploys).

Besides the GitLab repository [`zdaarau/rpkgs/rdb.report`](https://gitlab.com/zdaarau/rpkgs/rdb.report) that contains this very R package, we use

-   the GitLab repository [**`zdaarau/meta/rdb`**](https://gitlab.com/zdaarau/meta/rdb/) to collect [issues](https://gitlab.com/zdaarau/meta/rdb/-/issues)
    around the RDB that are not directly related to specific code but generally apply to the RDB data or structure. The repository is public.

-   a dedicated SWITCHDrive ([ownCloud](https://en.wikipedia.org/wiki/OwnCloud)) folder [**`RDB`**](https://drive.switch.ch/index.php/f/6665935856) to share
    non-code-related files around the RDB. Access is restricted to project members only.

-   a dedicated [Matrix](https://en.wikipedia.org/wiki/Matrix_(protocol)) chat room [**RDB**](https://matrix.to/#/#rdb:matrix.org) for ad-hoc communication
    (mainly in German) and an [OpenTalk](https://opentalk.eu/) conference room [**RDB
    Sync**](https://opentalk.mailbox.org/invite/cd9de4a1-9279-4e2d-9888-f188de4a022e) hosted on mailbox.org. Access to both is restricted to project members
    only.

# Comment on the report

## Interactively

For the [published report](https://report.rdb.vote/), the [Hypothes.is](https://en.wikipedia.org/wiki/Hypothes.is) annotation system is integrated directly into
the website[^1]. No additional browser plug-in is required. Simply open the Hypothes.is sidebar by clicking the <kbd>\<</kbd> button at the far right of the
page to access the full user interface.

Annotations (visible to others) and highlights (only visible to yourself) can be made directly by selecting any text on the report website. See [this help
article](https://web.hypothes.is/help/whats-the-difference-between-an-annotation-and-a-highlight/) to learn more about the different types of annotations that
are supported.

Annotations are stored in the currently selected group. By default, this is the world-readable group
[*Public*](https://hypothes.is/groups/__world__/public?q=report.rdb.vote). But you can select any other group you're a member of, as well as *🔒 Only Me* to
keep an annotation private to yourself. For internal review, we use the private group [*RDB*](https://hypothes.is/groups/B8N5yjMP/rdb).

Annotations can be formatted via [Markdown syntax](https://web.hypothes.is/help/formatting-annotations-with-markdown/).

[^1]: Quarto provides [built-in Hypothes.is integration](https://quarto.org/docs/output-formats/html-basics.html#commenting).

## Via e-mail

We also invite our readers to provide feedback via e-mail to our `feedback@` address which is an alias for the `info@` mailbox. The webmail interface of this
mailbox is accessible [here](https://webmail.gandi.net/SOGo/). Login credentials must be obtained from [\@salim-b](https://gitlab.com/salim-b).

# Edit the report

The report is produced using the [Quarto](https://quarto.org/) framework -- the powerful successor to the [R Markdown](https://rmarkdown.rstudio.com/) format --
which comes as a [CLI](https://quarto.org/docs/get-started/) and an accompanying [R package](https://quarto.org/docs/tools/rstudio.html#r-package).

The report's Quarto project files are located at [`input/report/`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/).

The **main Quarto Markdown book chapter source files** are (relative to path `input/report/`):

```{r}
#| label: report-filenames
#| echo: false
#| results: asis

as_gitlab_link <- function(x) {
  purrr::map_chr(x, \(el) glue::glue("[**`{el}`**](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/{el})"))
}

config <- rdb.report:::report_quarto_config(profile = "web")

filenames <-
  c(purrr::chuck(config,
                 "book", "chapters"),
    purrr::chuck(config,
                 "book", "appendices")) |>
  unlist(use.names = FALSE) |>
  setdiff(c("rdb_report.qmd",
            "index.qmd"))

is_gen <- stringr::str_detect(filenames, "^regional/\\w+/")

filenames[is_gen] %<>%
  stringr::str_replace("index.qmd$",
                       "_intro.qmd") %>%
  as_gitlab_link() %>%
  paste0("`", filenames[is_gen], "` \u2190 ", .)

filenames[!is_gen] %<>% as_gitlab_link()

filenames %>%
  c("[**`index.qmd`**](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/index.qmd) (report's landing page)", .) |>
  pal::as_md_list() |>
  cat()
```

```{r, 'regional-notes', include = any(is_gen), engine = "asis"}
<sup>All the `.qmd` files above with a filename starting with an underscore (`_`) are programmatically included[^q-incl] in the respective pre-assembled `.qmd`
file listed to the left of the arrow. Pre-assembled files are not intended to be edited by hand since they are regularly re-generated from scratch using
[`rdb.report::preassemble()`](https://rdb.report.rpkg.dev/reference/preassemble.html).</sup>

Optionally, there can be one file for each country in the regional analysis part under `regional/{continent}/_intro_{country_name}.qmd`[^repl] meant to contain
a country-specific intro. These files are automatically included[^incl-shortcode] in the corresponding pre-assembled `regional/{continent}/index.qmd` file
listed above.

[^q-incl]: Via [Quarto's `include` shortcode](https://quarto.org/docs/authoring/includes.html).

[^repl]: Replace `{continent}` with the lowercase name of the corresponding tier-1 world region (e.g. `europe`), and `{country_name}` with the country's actual
    `country_name` converted to [snake_case](https://en.wikipedia.org/wiki/Snake_case) (e.g. `united_kingdom`).

[^incl-shortcode]: Via [Quarto's `include` shortcode](https://quarto.org/docs/authoring/includes.html).
```

The *rendered* report files are located at [`output/report/`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/output/report/). The published report
available at [report.rdb.vote](https://report.rdb.vote/) is directly deployed from the [GitLab repository's `master`
branch](https://gitlab.com/zdaarau/rpkgs/rdb.report/tree/master/output/report/). ***Please do not stage and commit any files under the `output/` folder unless
you exactly know what you're doing!***[^2]

[^2]: Usually, [\@salim-b](https://gitlab.com/salim-b) is responsible to update the published report. Please contact him if in doubt.

## Setup

To be able to work on the report, you either need an account[^3] on our [**preconfigured RStudio Server**](https://rstudio.rdb.vote/) (recommended)[^4] or set
up the RStudio Desktop IDE[^5] plus all other requirements in your local environment according to the following instructions.

<details>

<summary>Local setup instructions:</summary>

1.  *(optional, but recommended)* Install a package manager.

    -   *Windows*: Install [**Windows Package Manager (winget)**](https://learn.microsoft.com/windows/package-manager/)[^6].

        Available packages can be browsed [here](https://winget.run/search).

    -   *macOS*: Install [**Homebrew**](https://brew.sh/).

        Available packages can be browsed [here](https://formulae.brew.sh/).

    <sub>Installing the software below via a package manager is by far the most convenient choice, but of course you can also use other installation
    methods.</sub>

2.  Install the [**Git**](https://git-scm.com/download/) version control system.

    -   On Windows via winget: [`winget install --exact --id Git.Git`](https://winget.run/pkg/Git/Git)

    -   On macOS via Homebrew: [`brew install git`](https://formulae.brew.sh/formula/git)

3.  Install the latest version of [**R**](https://cloud.r-project.org/).

    -   On Windows via winget: [`winget install --exact --id RProject.R`](https://winget.run/pkg/RProject/R) plus
        [`winget install --exact --id RProject.Rtools`](https://winget.run/pkg/RProject/Rtools)

    -   On macOS via Homebrew: [`brew install r`](https://formulae.brew.sh/formula/r)

4.  Install the latest version of [**RStudio** Desktop](https://www.rstudio.com/products/rstudio/download/#download).

    -   On Windows via winget: [`winget install --exact --id RStudio.RStudio.OpenSource`](https://winget.run/pkg/RStudio/RStudio.OpenSource)

    -   On macOS via Homebrew: [`brew install --cask rstudio`](https://formulae.brew.sh/cask/rstudio)

5.  Install the latest version of [**Quarto**](https://quarto.org/docs/get-started/).

    -   On Windows via winget: [`winget install --exact --id RStudio.quarto`](https://winget.run/pkg/RStudio/quarto)

    -   On macOS via Homebrew: [`brew install --cask quarto`](https://formulae.brew.sh/cask/quarto)

6.  Install a [TeX Live](https://en.wikipedia.org/wiki/TeX_Live) distribution. It is strongly recommended to use [**TinyTeX**](https://yihui.org/tinytex/) since
    it is small in size and allows missing LaTeX packages to be automatically installed when rendering the report via RStudio.

    For both Windows and macOS, refer to TinyTeX's [official installation instructions](https://yihui.org/tinytex/#for-r-users).

7.  If not already done, create an [SSH key](https://docs.gitlab.com/ee/ssh/).

    -   On Windows: Set up SSH following [this
        tutorial](https://blog.devgenius.io/set-up-ssh-key-and-git-integration-in-windows-10-native-way-c9b94952dd2c?gi=71c7f64d669d).

    -   On macOS: Make sure to [configure SSH to use the system's keychain](https://apple.stackexchange.com/a/250572).

8.  [Create a GitLab account](https://gitlab.com/users/sign_up) and [add your public SSH key](https://gitlab.com/-/profile/keys).

9.  Let [\@salim-b](https://gitlab.com/salim-b) give you [developer access to this repository](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/project_members).

10. [Clone](https://docs.gitlab.com/ee/gitlab-basics/start-using-git.html#clone-a-repository) this repository using SSH to a local directory of your choice.

11. Open the report's project file [`input/report/report.Rproj`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/report.Rproj) in
    RStudio. [renv's private package library](#r-packages) should be automatically populated during the first startup.

    After that, everything should be ready. ✨

    To later upgrade all of the software installed via the package manager at once, run:

    -   On macOS: [`brew update; brew upgrade`](https://docs.brew.sh/FAQ#how-do-i-update-my-local-packages)

    -   On Windows: [`winget upgrade --all`](https://learn.microsoft.com/windows/package-manager/winget/upgrade)

</details>

[^3]: Currently, accounts exist for [\@jowuet](https://gitlab.com/jowuet), [\@juriezzaini](https://gitlab.com/juriezzaini),
    [\@polaris808](https://gitlab.com/polaris808), [\@RobinTGut](https://gitlab.com/RobinTGut), [\@the-schoscho](https://gitlab.com/the-schoscho),
    [\@serdult](https://gitlab.com/serdult) and [\@zdaarau-salim](https://gitlab.com/zdaarau-salim).

[^4]: The server VM is configured to automatically scale to zero after the last user session is terminated. This means that the whole VM is reset once the last
    user quits their session or is inactive for more than 1 hour (after which their session is automatically killed).

    Users **should** make sure to **commit and push** their pending changes before quitting their session since the Git repository clone on the RStudio Server
    is supposed to be reset to a clean state regularly (i.e. on every VM update).

    In addition, it's recommended to explicitly end the session when finished working. To do so, simply press the red power-off button on the top right and then
    close the web browser tab. This allows to save on computing resources, i.e. energy. Otherwise, the VM will keep on running for an additional hour.

[^5]: *IDE* stands for ***I**ntegrated **D**evelopment **E**nvironment*, a software application that provides comprehensive facilities to computer programmers
    for software development. More information can be found on [Wikipedia](https://en.wikipedia.org/wiki/Integrated_development_environment).

[^6]: There are other viable package managers available for Windows, including [Scoop](https://scoop.sh/) and [Chocolatey](https://chocolatey.org/). Packages
    available for Scoop can be browsed [here](https://scoop.sh/#/apps), those for Chocolatey [here](https://community.chocolatey.org/packages). While Chocolatey
    has the larger user base, Scoop is technically [more promising](https://github.com/ScoopInstaller/Scoop/wiki/Chocolatey-and-Winget-Comparison) and its
    package repositories seem to be better maintained.

## Editor

For RStudio users it's **strongly recommended** to start by opening the RStudio project file
[**`report.Rproj`**](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/report.Rproj)[^7] which happens automatically on login to our
[preconfigured RStudio Server](https://rstudio.rdb.vote/).

Besides editing in raw source mode, RStudio users can optionally switch to the [visual Markdown editing
mode](https://rstudio.github.io/visual-markdown-editing/) which shows a semi-rendered [WYSIWY**G**](https://en.wikipedia.org/wiki/WYSIWYG) view and offers a
graphical user interface for the most widely used parts of the Quarto Markdown syntax. But since the very idea of this visual mode fundamentally breaks with
Markdown's [WYSIWY**M**](https://en.wikipedia.org/wiki/WYSIWYM) paradigm, it's recommended to be used with caution.

RStudio's Markdown [canonicalization](https://rstudio.github.io/visual-markdown-editing/markdown.html#canonical-mode) is activated globally, meaning each time a
(Quarto) Markdown document is saved, it is normalized via a Pandoc[^8] "round trip" in the background. This usually alters the formatting (but not the
semantics), which can be irritating at first. But the gained syntax standardization and visual homogeneity far outweigh this disturbance. A detailed list of how
Markdown elements may be altered during canonicalization is found [here](https://quarto.org/docs/visual-editor/markdown.html#overview).

[^7]: Otherwise, certain user interface elements like the <kbd>Build Book</kbd> button and [RStudio's built-in citation insertion
    interface](https://rstudio.github.io/visual-markdown-editing/citations.html#inserting-citations) as well as other convenience features won't work as
    intended.

[^8]: [Pandoc](https://pandoc.org/), a "universal document converter", is the software that also powers the rendering of Quarto content to HTML, PDF, DOCX etc.
    output in the first place. Simply put: It is one of the most underappreciated pieces of software out there -- and of course, it's open source.

## Structure and metadata {#structure-and-metadata}

We use a Quarto project of type [**book**](https://quarto.org/docs/reference/projects/books.html) for the RDB report. The report's metadata is specified via
[Quarto project configuration file(s)](https://quarto.org/docs/projects/quarto-projects.html#shared-metadata) in [YAML](https://en.wikipedia.org/wiki/YAML)
format. Refer to Quarto's [book options reference](https://quarto.org/docs/reference/projects/books.html) for supported configuration values.

We specify multiple Quarto [project profiles](https://quarto.org/docs/projects/profiles.html) to flexibly generate different report versions from the same
content pool, depending on the output format (HTML, PDF etc.) and the edition (i.e. publication year).

Currently, we have specified the Quarto profiles `r rdb.report:::report_quarto_profiles() |> pal::enum_str(wrap = "\x60")` via the following **Quarto profile
configuration files** (relative to path `input/report/`):

```{r}
#| label: quarto-profile-filenames
#| echo: false
#| results: asis

rdb.report::path_pkg_repo("input/report") |>
  fs::dir_ls(type = "file",
             glob = "*/_quarto*.yml") |>
  fs::path_rel(start = rdb.report::path_pkg_repo("input/report")) |>
  sort(decreasing = TRUE) |>
  as_gitlab_link() |>
  pal::as_md_list() |>
  cat()
```

### Start a new report edition

To begin a new report edition[^9], follow these steps:

1.  Create a new Quarto profile for the last edition's `print` version, so the PDF version of that edition can still be rebuilt in case something needs
    correction.

    To do so, create a new text file `input/report/_quarto-print_YYYY.yml` where `YYYY` corresponds to the last edition's publication year. Copy all the
    edition-specific metadata from
    [`input/report/_quarto.yml`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto.yml?ref_type=heads) to that file[^10]. See
    [`input/report/_quarto-print_2023.yml`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-print_2023.yml?ref_type=heads) for an
    example.

2.  Make the main `index.qmd` file(s) content of the part(s) introduced in the new edition
    [conditional](https://quarto.org/docs/authoring/conditional.html#matching-against-metadata) on suitable `custom.incl_part_*` metadata. See
    [`input/report/overall/index.qmd`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/overall/index.qmd?ref_type=heads) for an example.

3.  Update the main Quarto profile config file
    [`input/report/_quarto.yml`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto.yml?ref_type=heads) to the new edition (authors,
    publication year etc.). Don't forget to update the `custom.incl_part_*` metadata[^11].

4.  Update the [`web`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-web.yml?ref_type=heads) and
    [`print`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/_quarto-print.yml?ref_type=heads) Quarto profiles to include the new
    edition's part(s) and chapters in the correct order. The newest part(s), i.e. the one(s) introduced with the new edition, should come *first*.

    Don't forget to add `custom.incl_part_*` metadata in the `web` profile for the part(s) introduced in the new edition[^12].

5.  Add a cover page for the new edition.

    To do so, create a new file `input/report/assets/cover_page_YYYY.odt` where `YYYY` corresponds to the new edition's publication year and adapt it as needed.
    The most efficient way to do so is copy-pasting the last edition's cover page and updating it accordingly. When finished, render that file to PDF (e.g.
    using [LibreOffice](https://libreoffice.org)).

[^9]: I.e. increase the publication year by 1.

[^10]: The metadata in `_quarto-print_YYYY.yml` takes precedence over and is complemented by the main `_quarto.yml` profile config file, as it is the case for
    all profiles.

[^11]: Only the part(s) introduced in the new edition should be included by default.

[^12]: The HTML version of the report is supposed to always include all parts.

## Code chunk options

To specify options that apply to a code chunk, like [output](https://quarto.org/docs/computations/execution-options.html#output-options),
[layout](https://quarto.org/docs/authoring/article-layout.html#code-cell-options) or [knitr](https://quarto.org/docs/reference/cells/cells-knitr.html) options,
write them in special comments at the top of the code chunk, e.g.:

``` r
#| label: "fig-airquality"
#| fig-cap: "Air Quality"
#| fig-column: page
```

The following code chunk options are set by default[^13], thus no need to explicitly specify them:

```{r}
#| label: default-chunk-opts
#| echo: false

list(web = rdb.report:::report_quarto_config(profile = "web"),
     print = rdb.report:::report_quarto_config(profile = "print")) |>
  purrr::imap(\(config, profile) {
    
    config |>
      purrr::pluck("knitr", "opts_chunk") |>
      purrr::imap(\(val,
                    key) {
        
        if (is.character(val)) val %<>% pal::wrap_chr()
        
        tibble::tibble(option = pal::wrap_chr(key,
                                              wrap = "`"),
                       `default value` = pal::wrap_chr(val,
                                                       wrap = "`"),
                       profiles = pal::wrap_chr(pal::wrap_chr(profile),
                                                wrap = "`"))
      }) |>
      purrr::list_rbind()
  }) |>
  purrr::list_rbind() |>
  dplyr::summarise(profiles = paste0(profiles,
                                     collapse = ", "),
                   .by = c(option, `default value`)) |>
  pal::pipe_table() |>
  # linkify 'profiles' table header
  stringr::str_replace(pattern = "\\Q**profiles**\\E",
                       replacement = "[**profiles**](https://rdb.report.rpkg.dev/reference/report_render#arg-profile)") |>
  magrittr::set_attr(which = "format",
                     value = "pipe") |>
  magrittr::set_class(value = "knitr_kable")
```

[^13]: These options are set in the [Quarto profile configuration files](#structure-and-metadata).

## Cross references

Quarto enables you to create [cross-references to figures, tables, equations, sections, code listings, theorems, proofs, and
more](https://quarto.org/docs/authoring/cross-references.html). RStudio's visual Markdown editing mode offers a convenient
[autocompletion](https://rstudio.github.io/visual-markdown-editing/markdown.html#cross-references) feature based on all existing cross-referenceable
labels[^14].

Examples of the most important cross reference types are given below.

[^14]: Note that cross references only work with *numbered* navigation targets, which means [`number-sections` must be set to `true` for sections to be
    cross-referenceable](https://quarto.org/docs/authoring/cross-references.html#sections). This is the [default for Quarto
    book](https://quarto.org/docs/books/book-structure.html#chapter-numbers) projects.

### Figures

To [refer to a figure](https://quarto.org/docs/authoring/cross-references.html#figures) labelled `fig-airquality` you simply write:

``` rmd
See @fig-airquality.
```

To [refer to a *sub*figure](https://quarto.org/docs/authoring/cross-references.html#computations) you append the numerical subfigure rank to the figure label.
To refer to the first subfigure of a figure group labelled `fig-airquality`, you write:

``` rmd
See @fig-airquality-1.
```

See Quarto's [documentation](https://quarto.org/docs/authoring/cross-references.html#computations) on how to create cross-referenceable figures from R code.

### Tables

To [refer to a table](https://quarto.org/docs/authoring/cross-references.html#tables) labelled `tbl-letters`, you analogously write:

``` rmd
See @tbl-letters.
```

See Quarto's [documentation](https://quarto.org/docs/authoring/cross-references.html#computations-1) on how to create cross-referenceable tables from R code.

### Sections

To [refer to a *numbered* section](https://quarto.org/docs/authoring/cross-references.html#sections) labelled `sec-intro`, you analogously write:

``` rmd
See @sec-intro.
```

To label the section title with the ID `sec-intro`, write:

``` md
# Introduction {#sec-intro}
```

Note that currently only book *chapters* are cross-referenceable, book *parts* are not.

### Arbitrary elements

To create [hyperlinks](https://quarto.org/docs/books/book-crossrefs.html#hyperlinks) (but not actual *cross references*) to elements that are not covered by
Quarto's cross reference syntax, you can use standard Markdown links to the relevant Quarto Markdown source file (and fragment). To link to the term *World
region* in our [glossary](https://report.rdb.vote/glossary.html), you could write:

``` rmd
The report's regional part is divided into [world regions](glossary.qmd#world-region).
```

Note that we appended the fragment identifier (`#world-region`) to the source file path (`glossary.qmd`) in order to directly link to the exact place in the
glossary where *World region* is defined.

Such hyperlinks work in both HTML and PDF output. But in contrast to actual Quarto cross references, these hyperlinks become useless when the output document is
printed since no human-parsable navigation hint is generated (such as an element number like "Figure 4.2").

## Citations / Bibliography

The bibliographic metadata for this report is stored in the public [Zotero](https://en.wikipedia.org/wiki/Zotero) library
[**`rdb_report`**](https://www.zotero.org/groups/4604812/rdb_report/library). Only group members have write access. We either set citation keys manually for new
items or rely on the Zotero add-on [Better BibTeX (BBT)](https://retorque.re/zotero-better-bibtex/) for [generation of stable citation
keys](https://retorque.re/zotero-better-bibtex/citing/)[^15]. Citation keys are stored ("pinned")[^16] in the `Extra` field[^17] of an item.

The whole `rdb_report` Zotero group library is exported to the CSL-JSON file
[`assets/bibliography.json`](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/assets/bibliography.json) via
[`report_update_bib()`](https://rdb.report.rpkg.dev/reference/report_update_bib.html), which is executed every time the report is
[rendered](#render-the-report). This file is then referenced as bibliographic metadata source in the Quarto configuration.

Citations can be inserted using [Pandoc's citation syntax](https://quarto.org/docs/authoring/footnotes-and-citations.html#sec-citations). RStudio's offers a
very convenient [citation insertion feature](https://rstudio.github.io/visual-markdown-editing/citations.html#inserting-citations) which allows to search the
whole bibliography and offers citation key autocompletion. Unfortunately, it's only available in [visual Markdown editing
mode](https://rstudio.github.io/visual-markdown-editing/) and not (yet) in source editing mode.

```{r}
#| label: csl
#| include: false

csl <-
  rdb.report::path_pkg_repo("input/report/assets/citation_style.csl") |>
  xml2::read_xml() |>
  xml2::xml_child(search = "d1:info")

csl_title <-
  csl |>
  xml2::xml_child(search = "d1:title") |>
  xml2::xml_text()

csl_id <-
  csl |>
  xml2::xml_child(search = "d1:id") |>
  xml2::xml_text() |>
  # replace Zotero URL with GH repo URL
  stringr::str_extract("[^/]+$")

csl_url <- paste0("https://github.com/citation-style-language/styles/blob/", rdb.report:::csl_repo_branch_latest(), "/", csl_id, ".csl")
csl_link <- glue::glue("[`{csl_id}`]({csl_url})")
```

To format citation references, the [citation style](https://en.wikipedia.org/wiki/Citation_Style_Language) *`r csl_title`* (`r csl_link`) is used. This style
also defines how the titles of the cited literature are formatted, based on their language codes (set in the `Language` field): For all items with an `en`
language code set, titles are automatically formatted in [title case](https://en.wikipedia.org/wiki/Title_case). The same applies to items without an explicit
language code set (`en` is assumed in that case). For all other languages, titles are formatted as-is, i.e. as written in the Zotero library.

To manually control how titles are formatted, you can resort to a [set of specific HTML tags](https://www.zotero.org/support/kb/rich_text_bibliography). The
automatic title-casing can be avoided by wrapping text in `<span class="nocase">...</span>`. This allows to e.g. correctly format a German title in an English
Zotero item.

[^15]: We use BBT's [default `[auth:lower][shorttitle3_3][year]` pattern](https://retorque.re/zotero-better-bibtex/citing/#configurable-citekey-generator) for
    citation key generation.

    To give some background on the whole citation standardization situation:

    For the storage of bibliographic metadata in general and the citation keys (or short "citekeys") to identify individual bibliography items in particular,
    only in recent years a well-defined and open standard has become widely established:
    [**CSL-JSON**](https://github.com/citation-style-language/schema/#csl-json-schema). It offers i.a. a dedicated [`citation-key`
    field](https://github.com/citation-style-language/schema/blob/master/schemas/input/csl-data.json#L62-L64) which [differs from the `id`
    field](https://github.com/citation-style-language/schema/issues/243#issuecomment-643635052) in that it is meant for a *locally* unique identifier while the
    latter is designed to be a [*globally* unique identifier](https://en.wikipedia.org/wiki/Universally_unique_identifier) (for which considerably more entropy
    is required, e.g. a 128-bit hash value, thus rendering it almost impossible to be user-memorizable).

    Unfortunately, the development of Zotero's internal metadata structure predates CSL-JSON by more than a decade and there are significant differences between
    the two. To convert from one to another, non-trivial conversion steps are required. Specifically, Zotero has no notion of *stable* (and thus user-friendly)
    citation keys. Its internal data model [doesn't (yet) have a native field for them](https://forums.zotero.org/discussion/comment/318884/#Comment_318884)
    like CSL-JSON does with `citation-key`. Instead, Zotero auto-generates the keys only during export based on bibliography data like an author name or title
    and offers the user no means to customize them.

    Solving these issues has presumably been neglected in Zotero's development because its main target user group relies on
    [WYSIWY**G**](https://en.wikipedia.org/wiki/WYSIWYG) editors like LibreOffice or Microsoft Word and their respective Zotero plugins which use other means to
    identify individual bibliography items. In contrast, [WYSIWY**M**](https://en.wikipedia.org/wiki/WYSIWYM) editors -- or more precisely their underlying
    syntaxes like LaTeX or [(Pandoc's) Markdown](https://pandoc.org/MANUAL.html#pandocs-markdown) which properly separate content from presentation -- solely
    rely on (user-memorizable) citation keys like `greenFewThoughtsSignal2020` as identifiers for bibliography items, hence they must only change on user
    request after the item's initial creation.

    This is where BBT shines: It extends Zotero with the ability to create stable citation keys, besides offering other enhancements tailored to WYSIWYM users.

[^16]: BBT by default only "pins" citation keys on explicit request but there's a [separate configuration option to automatically pin citation keys after the
    chosen amount of seconds](https://retorque.re/zotero-better-bibtex/installation/preferences/#automatically-pin-citation-key-after) which we recommend to set
    to the value `3` (meaning the citation key is automatically pinned 3 seconds after an item's creation).

[^17]: Identified by the prefix `Citation Key:` and separated from other content in the same field by simple newlines (`\n`).

## Language style

### Capitalization of titles

We do *not* use [title case](https://en.wikipedia.org/wiki/Title_case), partly because the corresponding rules [are not universally
standardized](https://en.wikipedia.org/wiki/Letter_case#Headings_and_publication_titles). Instead, we write titles like the rest of the text in [sentence
case](https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage), something that, for example, also the International Organization for
Standardization does in its own publications.

## R packages {#r-packages}

To provide a reproducible R environment including the exact version of all necessary R packages, we rely on
[renv](https://rstudio.github.io/renv/articles/renv.html).

We use renv's [`"explicit"` snapshot type](https://rstudio.github.io/renv/reference/snapshot.html#snapshot-type) in which the following steps are required in
order to introduce a new R package dependency `PKG_NAME`:

1.  Add `PKG_NAME` including possible remotes to the [report's `DESCRIPTION`
    file](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/DESCRIPTION).

2.  Run in an R console:

    ``` r
    renv::install("PKG_NAME",
                  prompt = FALSE,
                  lock = TRUE)
    ```

The project's renv snapshot state will be [restored](https://rstudio.github.io/renv/reference/restore.html) during R session initialization, i.e. when executing
the report's [`.Rprofile` file](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/blob/master/input/report/.Rprofile), so no manual action is required by
collaborators to bring their renv libraries up to date. Depending on the extent of snapshot changes, this can take a considerable amount of time (up to several
minutes). The following message displayed on the console will indicate when renv project restoral is completed:

```         
✔ Restoring renv state done. Ready to go.
```

# Render the report {#render-the-report}

To view the rendered report locally, e.g. to preview recent edits, [`quarto preview`](https://quarto.org/docs/get-started/hello/text-editor.html#authoring) or
[`quarto render`](https://quarto.org/docs/projects/quarto-projects.html#rendering-projects) must be executed. The former is intended for continuously previewing
the report locally and continues running Quarto in the background after the initial render phase to automatically rebuild affected parts of the report when
input files change[^18]. RStudio's built-in <kbd>Render</kbd> button on open `.qmd` files as well as the <kbd>Render Book</kbd> button in the <kbd>Build</kbd>
pane both launch `quarto preview` in the background[^19].

Unfortunately, even partial rendering is often too slow for Quarto's preview functionality to feel like an actual real-time editing experience. So we recommend
to avoid it and instead call our custom RStudio add-ins *on demand* that execute
[`rdb.report::report_render()`](https://rdb.report.rpkg.dev/reference/report_render) and
[`rdb.report::report_render_partly()`](https://rdb.report.rpkg.dev/reference/report_render_partly) which run `quarto render` without launching a continuous
preview.

Another shortcoming of RStudio's Quarto integration is that it doesn't allow to choose the Quarto profile, meaning the <kbd>Render</kbd> and <kbd>Render
Book</kbd> buttons will always only render the *default*[^20] profile. The arrow next to each of the render buttons only allows to select the *output
format*[^21], but not the *profile*. Unfortunately, the two concepts are somewhat orthogonal to each other.

In our case, however, we only ever want to render a profile to one specific output format (`web` to HTML, `print` to PDF), but Quarto does not allow to assign a
specific output format to a profile or anything like that. Therefore, `rdb.report::report_render()` contains some additional logic to automatically select our
desired output format if it is not explicitly specified[^22].

Finally, note that rendering the report writes the output to `output/report/`. The [report.rdb.vote](https://report.rdb.vote/) website is deployed from [this
subdirectory of the GitLab remote](https://gitlab.com/zdaarau/rpkgs/rdb.report/-/tree/master/output/report). Thus, **commiting and pushing changes under
`output/report/` directly updates the live report**.

[^18]: Everytime an input file or document resource (e.g. CSS) is changed on disk (i.e. saved), the corresponding chapter is rebuilt and the browser window is
    automatically reloaded.

[^19]: `quarto preview` can also be launched via `quarto::quarto_preview(file = rdb.report::path_pkg_repo("input/report"))`. It can be stopped again via
    `quarto::quarto_preview_stop()` or by restarting the R session.

[^20]: Which profile is default is defined in `_quarto.yml` (the first element of `profile.group`), currently this is the
    **`r rdb.report::path_pkg_repo("input/report") |> quappo::default_profiles() |> pal::wrap_chr("\x60")`** profile.

[^21]: Corresponding to `quarto::quarto_render()`'s [`output_format`](https://quarto-dev.github.io/quarto-r/reference/quarto_render.html#arg-output-format)
    parameter.

[^22]: I.e. if [`output_format = NULL`](https://rdb.report.rpkg.dev/reference/report_render#arg-output-format)

## Complete render

To re-render the full report to HTML, either invoke the <kbd>*Render report to HTML*</kbd> command via RStudio's [command
palette](https://www.rstudio.com/blog/rstudio-1-4-a-quick-tour/#command-palette--shortcuts)[^23] or run the following command directly from any R console with
its [working directory](https://rdrr.io/r/base/getwd.html) set to a (sub)path of this repository:

``` r
rdb.report::report_render(profile = "web")
```

Or – since `profile = "web"` is the default – just:

``` r
rdb.report::report_render()
```

To render to PDF instead, run

``` r
rdb.report::report_render(profile = "print")
```

[^23]: On Linux and Windows, the default shortcut to open RStudio's command palette is <kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>P</kbd>, while on macOS the default
    is <kbd>Cmd</kbd>+<kbd>Shift</kbd>+<kbd>P</kbd>. Note that on the [RDB RStudio Server](https://rstudio.rdb.vote/), the shortcut is
    <kbd>Ctrl</kbd>+<kbd>P</kbd> by default.

## Partial render

Quarto supports [incremental rendering](https://quarto.org/docs/projects/code-execution.html#incremental-render) for HTML output[^24]. This allows to quickly
iterate on the report by only re-rendering the chapter or part you're currently working on.

To re-render the currently opened file, invoke the <kbd>*Render report partly to HTML*</kbd> command via RStudio's command palette.

You can also re-render a single report chapter or part directly from any R console with its [working directory](https://rdrr.io/r/base/getwd.html) set to a
(sub)path of this repository. To re-render e.g. just the `r as_gitlab_link("overall")` part, run:

``` r
rdb.report::report_render_partly(path = rdb.report::path_pkg_repo("input/report/overall"))
```

[^24]: Unfortunately, incremental rendering is not supported for PDF output. This means that if you instruct Quarto to only render a single chapter to PDF (e.g.
    via `rdb.report::report_render_partly(path = rdb.report::path_pkg_repo("input/report/intro.qmd"), profile = "print")`), the entire report will still be
    rendered.

## Static preview

To view the rendered[^25] report *immediately* from any R console with its [working directory](https://rdrr.io/r/base/getwd.html) set to a (sub)path of this
repository, run:

``` r
rdb.report::report_view()
```

By default, the HTML version is opened, in RStudio's viewer pane if available[^26].

Alternatively, you can also invoke the <kbd>*View report in HTML*</kbd> command via RStudio's [command
palette](https://www.rstudio.com/blog/rstudio-1-4-a-quick-tour/#command-palette--shortcuts).

Note that on RStudio *Server*, it might happen from time to time that an error message `Connection refused` instead of the actual HTML version of the report is
displayed. While the exact cause of this issue is still unknown to us[^27], it can simply be remedied via a [*hard refresh* of the web
browser](https://www.howtogeek.com/672607/how-to-hard-refresh-your-web-browser-to-bypass-your-cache/), after which `rdb.report::report_view()` works as expected
again.

To view the PDF version instead, run:

``` r
rdb.report::report_view(profile = "print")
```

Note that this does *not* automatically re-render content on changes. Use [Quarto's preview functionality](#render-the-report) if you'd like that instead.

[^25]: Meaning the files under [`output/report/`](output/report/).

[^26]: Of course, the preview can be accessed using any (reasonably up-to-date) web browser by opening <http://127.0.0.1:3456> (`3456` is the default port which
    can be changed via the [`port` argument](https://rdb.report.rpkg.dev/reference/report_view#arg-port)).

[^27]: My best guess would be that it's related to some premature token expiration.

# Update report assets

Certain files required to build the report are only manually updated.

To update the Pandoc LaTeX template to the [latest version](https://gitlab.com/salim_b/pandoc/templates/), run:

``` r
salim::pandoc_tpl(tpl = "quarto_mod.latex") |> brio::write_file(path = rdb.report::path_pkg_repo("input/report/assets/template.latex"))
```

# Analytics

To measure the number and origin of visitors to the report website, we use the non-privacy-invading open source analytics service
[Counter](https://counter.dev/). The service doesn't collect or store any personal information from visitors and there are no cookies involved.

Guest access to the analytics dashboard is activated. It is accessible under [**this
URL**](https://counter.dev/dashboard.html?user=rdb.vote&token=L8SkjwQUvR4%3D).
